=== modified file 'udf/mariadb/error_handler.sql'
--- udf/mariadb/error_handler.sql	2022-08-17 06:40:50 +0000
+++ udf/mariadb/error_handler.sql	2023-02-12 14:29:52 +0000
@@ -1,11 +1,11 @@
 /*
 ** Module   : error-handlers.sql
-** Abstract : 'Native' versions of the ErrorHandler-based Java UDFs
+** Abstract : 'Native' versions of the ErrorHandler-based Java UDFs (MariaDB version)
 **
-** Copyright (c) 2021, Golden Code Development Corporation.
+** Copyright (c) 2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description----------------------------------
-** 001 IAS 20210803 Created initial version.
+** 001 IAS 20230208 Created initial version.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -62,24 +62,14 @@
 /**
  * Check if the error stack is active
  */
-##CREATE OR REPLACE FUNCTION udf.error_handler_active()
-CREATE OR REPLACE FUNCTION error_handler_active() ##!! TODO
-##RETURNS boolean 
+CREATE OR REPLACE FUNCTION error_handler_active()
 RETURNS BOOLEAN
 DETERMINISTIC
 BEGIN
-  RETURN null;
+  RETURN true; -- exists(select * from temp_error_stack where fwd_error_ctx = @fwd_error_ctx);
 END;
 $$
 
-##AS $function$
-##select exists (
-##   select 1
-##   from   information_schema.tables 
-##   where  table_schema like 'pg_temp_%'
-##   and table_name='temp_error_stack'
-##)
-##$function$
 
 /**
  * A special wrapper function for a UDF called
@@ -118,25 +108,21 @@
  * @return  false if an error occurred in this scope;
  *          otherwise, the result of the boolean sub-expression.
  */
-##CREATE OR REPLACE FUNCTION udf.initerror(state boolean) 
-CREATE OR REPLACE FUNCTION initerror_B(state BOOLEAN) ##!! TODO
-##RETURNS boolean 
+CREATE OR REPLACE FUNCTION initError_B(state BOOLEAN)
 RETURNS BOOLEAN
 DETERMINISTIC
 BEGIN
-  RETURN null;
+  call initError_P(state);
+  return true;
 END;
 $$
 
-##AS $function$
-##begin
-##   if not udf.error_handler_active() then  
-##      create temporary table if not exists temp_error_stack(id serial, state boolean not null) on commit drop;
-##   end if;
-##   insert into temp_error_stack(state) values (state);
-##   return true;
-##end;
-##$function$
+CREATE OR REPLACE PROCEDURE initError_P(state BOOLEAN)
+DETERMINISTIC
+BEGIN
+  insert into temp_error_stack(state,fwd_error_ctx) values (state, @fwd_error_ctx);
+END;
+$$
 
 /**
  * Initialize the error flag stack for the current function scope by
@@ -147,31 +133,41 @@
  * 
  * @return  Boolean.TRUE.
  */
-##CREATE OR REPLACE FUNCTION udf.checkerror(init boolean, result boolean)
-CREATE OR REPLACE FUNCTION checkerror_BB(init BOOLEAN, result BOOLEAN) ##!! TODO
-##RETURNS boolean 
+CREATE OR REPLACE FUNCTION checkError_BB(init BOOLEAN, result BOOLEAN)
 RETURNS BOOLEAN
 DETERMINISTIC
 BEGIN
-  RETURN null;
-END;
-$$
-
-##AS $function$
-##declare top bigint;
-##declare val boolean;
-##begin
-##   if not udf.error_handler_active() then  
-##      create temporary table if not exists temp_error_stack(id serial, state boolean not null) on commit drop;
-##   end if;
-##   top := (select max(id) from temp_error_stack);
-##   if top is null then
-##      return null;
-##--    raise exception 'Error stack is empty';
-##   end if;
-##   val := (select state from temp_error_stack where id = top);
-##   delete from temp_error_stack where id = top;
-##   return case when val then false else result end;
-##end;
-##$function$
+   declare top integer;
+   declare val boolean;
+   set top = (select max(id) from temp_error_stack);
+   if top is null then
+      return null;
+   end if;
+   set val = (select state from temp_error_stack where id = top);
+   delete from temp_error_stack where id = top;
+   return if(val, false, result);
+END;
+$$
+
+/**
+ * Activate error handler
+ */
+CREATE OR REPLACE PROCEDURE activateErrorHandler()
+DETERMINISTIC
+begin
+   truncate table temp_error_stack;
+   set @fwd_error_ctx = uuid();  
+END;
+$$
+
+/**
+ * Reset error handler
+ */
+CREATE OR REPLACE PROCEDURE resetErrorHandler()
+DETERMINISTIC
+begin
+   truncate table temp_error_stack;
+   set @fwd_error_ctx = null;  
+END;
+$$
 

=== added file 'udf/mariadb/guard.awk'
--- udf/mariadb/guard.awk	1970-01-01 00:00:00 +0000
+++ udf/mariadb/guard.awk	2023-02-12 13:38:24 +0000
@@ -0,0 +1,104 @@
+# Module   : guard.awk
+# Abstract : awk script for generating 'guarded' versions of the MariaDB UDFs
+#
+# Copyright (c) 2023, Golden Code Development Corporation.
+#
+# -#- -I- --Date-- --------------------------------Description----------------------------------
+# 001 IAS 20230308 Created initial version.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU Affero General Public License for more details.
+#
+# You may find a copy of the GNU Affero GPL version 3 at the following
+# location: https://www.gnu.org/licenses/agpl-3.0.en.html
+#
+# Additional terms under GNU Affero GPL version 3 section 7:
+#
+#   Under Section 7 of the GNU Affero GPL version 3, the following additional
+#   terms apply to the works covered under the License.  These additional terms
+#   are non-permissive additional terms allowed under Section 7 of the GNU
+#   Affero GPL version 3 and may not be removed by you.
+#
+#   0. Attribution Requirement.
+#
+#     You must preserve all legal notices or author attributions in the covered
+#     work or Appropriate Legal Notices displayed by works containing the covered
+#     work.  You may not remove from the covered work any author or developer
+#     credit already included within the covered work.
+#
+#   1. No License To Use Trademarks.
+#
+#     This license does not grant any license or rights to use the trademarks
+#     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+#     of Golden Code Development Corporation. You are not authorized to use the
+#     name Golden Code, FWD, or the names of any author or contributor, for
+#     publicity purposes without written authorization.
+#
+#   2. No Misrepresentation of Affiliation.
+#
+#     You may not represent yourself as Golden Code Development Corporation or FWD.
+#
+#     You may not represent yourself for publicity purposes as associated with
+#     Golden Code Development Corporation, FWD, or any author or contributor to
+#     the covered work, without written authorization.
+#
+#   3. No Misrepresentation of Source or Origin.
+#
+#     You may not represent the covered work as solely your work.  All modified
+#     versions of the covered work must be marked in a reasonable way to make it
+#     clear that the modified work is not originating from Golden Code Development
+#     Corporation or FWD.  All modified versions must contain the notices of
+#     attribution required in this license.
+
+# Generates 'guarded' versions of the UDFs
+# Usage: awk -f guard.awk <udfs.sql >guarded.sql
+
+BEGIN {
+print "-- The 'guarded' versions of SQL UDFs";
+print "-- Generated automatically from udfs.sql with guard.awk script.";
+print "-- DO NOT MODIFY!";
+}
+
+/\/\*/, /\*\// {
+   print $0;
+}
+
+match($0, "^CREATE *OR *REPLACE *FUNCTION *(.*)$", m) {
+   f = m[1];
+   print "create or replace function guarded_" f; 
+}
+/^RETURNS/ {
+   print tolower($0);
+   s = f; 
+   gsub(/\(50, 10\)/, "", s); 
+   gsub(/\(3\)/, "", s); 
+   gsub(/ JSON/, "", s);
+   gsub(/ [a-zA-Z]*\)/, ")", s);
+   gsub(/ [^,]*, */, ", ", s); 
+   gsub(/##!! TODO/, "", s);
+   print "deterministic";
+   print "begin";
+   print "declare tmp text;"
+   print "declare exit handler for SQLEXCEPTION";
+   print "  begin";
+   print "    GET DIAGNOSTICS CONDITION 1 @sqlstate = RETURNED_SQLSTATE,  @errno = MYSQL_ERRNO, @text = MESSAGE_TEXT;";
+   print "    set tmp = sformat('ERROR {} ({}): {}', @sqlstate, @errno, @text);";
+   print "    if error_handler_active() then";
+   print "      call initError_P(true);";
+   print "      signal sqlstate '01FWD' set message_text = tmp;";
+   print "      return null;";
+   print "    else";
+   print "      signal sqlstate 'FWD00' set message_text = tmp;";
+   print "    end if;";
+   print "  end;";
+   print "  return " s ";";
+   print "end;";
+   print "$$";
+}

=== modified file 'udf/mariadb/udfs.sql'
--- udf/mariadb/udfs.sql	2022-09-26 18:56:49 +0000
+++ udf/mariadb/udfs.sql	2023-02-12 13:50:42 +0000
@@ -6411,7 +6411,7 @@
    if upper(left(fmt, 5)) = 'HH:MM' then 
       return totimestring_lti(v, fmt, tz);
    else
-      return tostring_lt(v, fmt);
+      return tostring_nt(cast(v as DECIMAL(50, 10)), fmt);
    end if;
 END;
 $$

